'-------------------------------------------
' S U P E R  C O B R A
'      By Cronomantic
'--------------------------------------------
' Requiere ultima versión estable ZxBasic 1.17
' Se compila con:
'zxbc -t -B -a -o SuberCobra.tap --optimize 4 --explicit --strict --expect-warnings 99999 --org 0x8000 -H 255 --heap-address 0xBF00 -DTOP_ADDRESS=0xBF00 -DHIDE_LOAD_MSG  -D__ZXB_DISABLE_BOLD -D__ZXB_DISABLE_ITALIC -D__ZXB_DISABLE_SCROLL SuperCobra.bas
'-------------------------------------------------------------------
#ifndef TOP_ADDRESS
#define TOP_ADDRESS 0x10000
#endif

#include once <memcopy.bas>
#include once <keys.bas>
#include once <putchars.bas>
#include once <scrbuffer.bas>
#include once <clearbox.bas>
#include once <attr.bas>
#include once <zx0.bas>
#include once <retrace.bas>

#define TRUE  1
#define FALSE 0

'===========================================================

CONST BUFFERPLXSIZE AS uInteger = 2048
CONST BUFFERATTSIZE AS uInteger = 256

CONST BUFFERATTADDR AS uInteger = TOP_ADDRESS - BUFFERATTSIZE
CONST BUFFERPXLADDR AS uInteger = BUFFERATTADDR - BUFFERPLXSIZE

'===========================================================

#include once "maps.bas"
#include once "charset.bas"
#include once "udgset.bas"
#include once "screens.bas"

'===========================================================

DIM CHARS AS uInteger AT $5C36
DIM UDG AS uInteger AT $5C7B
DIM FRAMES AS uInteger AT $5C78

DIM playfield0(0 TO 63) AS uByte
DIM playfield1(0 TO 63) AS uByte
DIM eMissilesY(0 TO 7) AS uByte
DIM eMissilesEn(0 TO 7) AS uByte
DIM eFuelTanksY(0 TO 7) AS uByte
DIM eMeteorsY(0 TO 7) AS uByte

'===========================================================

#ifdef TEST_MODE
#define HISCORE_VAL 100
#else
#define HISCORE_VAL 500
#endif

DIM score AS uLong = 0
DIM hiScore AS uLong = HISCORE_VAL
DIM scoreStr AS String

DIM keyUp AS uInteger
DIM keyDown AS uInteger
DIM keyLeft AS uInteger
DIM keyRight AS uInteger
DIM keyShot AS uInteger
DIM keyBomb AS uInteger

DIM randomSeed AS uInteger
DIM screenPxlPtr AS uInteger
DIM screenAttPtr AS uInteger
DIM mapPtr AS uInteger
DIM newPlayfieldPtr AS uInteger
DIM oldPlayfieldPtr AS uInteger
DIM tmpInt0, tmpInt1, tmpInt2, tmpInt3 AS uInteger

DIM tmp0, tmp1, tmp2, tmp3, tmp4, tmp5 AS uByte
DIM tmp6, tmp7, tmp8, tmp9, tmp10, tmp11 AS uByte

DIM lives AS uByte
DIM fuel AS uByte
DIM stage AS uByte
DIM updateScore AS uByte
DIM updateFuel AS uByte
DIM updateState AS uByte

DIM frameCont AS uByte
DIM stageSize AS uByte
DIM x, y, c AS uByte

DIM px, py AS uByte
DIM mx, my AS uByte
DIM bx, by AS uByte

DIM keyUpPressed AS uByte
DIM keyDownPressed AS uByte
DIM keyLeftPressed AS uByte
DIM keyRightPressed AS uByte
DIM keyShotPressed AS uByte
DIM keyBombPressed AS uByte
DIM kempston AS uByte

DIM newPlayfield AS uByte
DIM scrollDone AS uByte
DIM eIndexY AS uByte
DIM eIndexYM AS uByte

DIM sfx AS uByte
DIM deathState AS uByte
DIM extraLifeGiven AS uByte
DIM meteorsEnabled AS uByte
DIM missilesEnabled AS uByte
DIM missilesBonus AS uByte
DIM cheatMode AS uByte = FALSE
DIM loopComplete AS uByte = FALSE

'===========================================================

CONST MAXFUEL AS uByte = 96
CONST EXTRAFUEL AS uByte = 32

CONST SCOREMISSSP AS uInteger = 1500
CONST SCOREFUEL AS uByte   = 10
CONST SCORELEFT AS uByte   = 1
CONST SCOREMISSEN AS uByte = 8
CONST SCOREMISS AS uByte   = 5

CONST STARTROW AS uByte    = 8
CONST STARTCOL AS uByte    = 8
CONST WIDTH AS uByte       = 16
CONST HEIGHT AS uByte      = 8

CONST FUELCOL AS uByte     = 6
CONST DATACOL AS uByte     = 26

CONST VOID AS uByte        = 0
CONST CHOPPER AS uByte     = 1
CONST FUELTANK AS uByte    = 3
CONST PMISSILE AS uByte    = 4
CONST PBOMB AS uByte       = 5
CONST EMISSILE AS uByte    = 6
CONST BRICK AS uByte       = 7
CONST FUELGAUGE AS uByte   = 16
CONST STAGEICON AS uByte   = FUELGAUGE + 16

'===========================================================
'----------------------------------------------------------
' Generador de números pseudo-aleatorios usado en Berzerk y Robotron
' De acuerdo a la descripción de este enlace:
' http://www.robotron2084guidebook.com/home/games/berzerk/mazegenerator/code/
'----------------------------------------------------------
FUNCTION RandomGen() AS uByte

  DIM seed AS uInteger = randomSeed

  LET randomSeed = randomSeed + randomSeed  ' * 2
  LET randomSeed = randomSeed + randomSeed  ' * 4
  LET randomSeed = randomSeed + seed + seed ' * 6
  LET randomSeed = randomSeed + seed + $3153
  RETURN CAST(uByte, randomSeed >> 8)

END FUNCTION
'----------------------------------------------------------
SUB Death()

  LET deathState = TRUE
  LET frameCont = 0

END SUB
'----------------------------------------------------------
SUB RestorePlayer()

  LET mx = 8
  LET by = 8
  LET fuel = MAXFUEL
  LET px = 0
  LET py = 3
  LET frameCont = 0

END SUB
'----------------------------------------------------------
'Obtener tecla pulsada para la redefinición de teclado
FUNCTION GetRedefinedKey() AS uInteger

  DIM key AS uInteger = 0

  DO
    DO LOOP UNTIL GetKeyScanCode() <> 0
    PAUSE 1 : PAUSE 1
    LET key = GetKeyScanCode()
  LOOP UNTIL key <> 0

  BEEP 0.02, 20
  BEEP 0.02, 18
  BEEP 0.02, 16
  BEEP 0.02, 14
  BEEP 0.02, 12

  DO LOOP UNTIL GetKeyScanCode() = 0
  PAUSE 1

  RETURN key

END FUNCTION
'----------------------------------------------------------
SUB SetDefaultKeys()

  'teclas por defecto
#ifdef TEST_MODE
  LET keyUp = KEYW
  LET keyDown = KEYS
  LET keyLeft = KEYA
  LET keyRight = KEYD
  LET keyShot = KEYSPACE
  LET keyBomb = KEYQ
#else
  LET keyUp = KEYQ
  LET keyDown = KEYA
  LET keyLeft = KEYO
  LET keyRight = KEYP
  LET keyShot = KEYSPACE
  LET keyBomb = KEYCAPS
#endif

END SUB
'----------------------------------------------------------
SUB SetSJ1Keys()

  LET keyUp = KEY9
  LET keyDown = KEY8
  LET keyLeft = KEY6
  LET keyRight = KEY7
  LET keyShot = KEY0

END SUB
'----------------------------------------------------------
SUB SetSJ2Keys()

  LET keyUp = KEY4
  LET keyDown = KEY3
  LET keyLeft = KEY1
  LET keyRight = KEY2
  LET keyShot = KEY5

END SUB
'----------------------------------------------------------
SUB ShowMenuScreen()

  BORDER 0: INK 0: PAPER 0 : CLS
  dzx0Mega(@menuPxl(0), $4000)
  dzx0Mega(@menuAtt(0), $5800)
  INK 4

END SUB
'----------------------------------------------------------
SUB SetScoreString()

  IF score >= 999999 THEN
    LET scoreStr = STR(999999)
  ELSE
    LET scoreStr = STR(score)
  END IF

  ON LEN(scoreStr) GOTO scLen0, scLen1, scLen2, scLen3, scLen4, scLen5, scLen6

scLen0:
  LET scoreStr = "      "
  RETURN
scLen1:
  LET scoreStr = "     " + scoreStr
  RETURN
scLen2:
  LET scoreStr = "    " + scoreStr
  RETURN
scLen3:
  LET scoreStr = "   " + scoreStr
  RETURN
scLen4:
  LET scoreStr = "  " + scoreStr
  RETURN
scLen5:
  LET scoreStr = " " + scoreStr
  RETURN
scLen6:

END SUB

'----------------------------------------------------------
'Bucle de juego
FUNCTION MainLoop() AS uByte

  LET updateFuel = TRUE
  LET updateState = TRUE
  LET updateScore = TRUE
  LET deathState = FALSE
  LET meteorsEnabled = FALSE
  LET missilesEnabled = TRUE
  LET missilesBonus = FALSE

  LET y = 0
  LET eIndexY = 0
  LET eIndexYM = 0

  IF stage = 1 THEN
    LET mapPtr = @stageMap1(0)
    LET stageSize = UBOUND(stageMap1, 1)
  ELSEIF stage = 2 THEN
    LET mapPtr = @stageMap2(0)
    LET stageSize = UBOUND(stageMap2, 1)
  ELSEIF stage = 3 THEN
    LET mapPtr = @stageMap3(0)
    LET stageSize = UBOUND(stageMap3, 1)
  ELSEIF stage = 4 THEN
    LET mapPtr = @stageMap4(0)
    LET stageSize = UBOUND(stageMap4, 1)
  ELSE
    LET mapPtr = @stageMapSP(0)
    LET stageSize = UBOUND(stageMapSP, 1)
  END IF

  LET stageSize = (stageSize + 1) >> 1

  LET newPlayfieldPtr = @playfield0(0)
  LET oldPlayfieldPtr = @playfield1(0)
  LET newPlayfield = TRUE
  LET scrollDone = FALSE

    'Main game loop
  DO
    'La pantalla actual
    LET tmpInt0 = newPlayfieldPtr
    LET tmpInt1 = mapPtr
    LET tmp1 = 0
    DO
      LET tmp0 = 0
      LET tmp7 = (tmp1 + y) < stageSize 'Posición fuera del mapa
      IF tmp7 THEN
        LET tmp2 = PEEK(tmpInt1)
      ELSE
        LET tmp2 = 0
      END IF
      DO
        IF tmp2 bAND %10000000 THEN
          LET tmp3 = BRICK
        ELSE
          LET tmp3 = VOID
        END IF
        POKE tmpInt0 + (tmp0 << 3), tmp3
        LET tmp2 = tmp2 << 1
        LET tmp0 = tmp0 + 1
      LOOP UNTIL tmp0 >= 8
      IF ((tmp1 = 7 AND scrollDone) OR newPlayfield) THEN
        scrollDone = FALSE
        LET tmp4 = 8
        LET tmp5 = 8
        IF tmp7 THEN
          LET tmp3 = PEEK(tmpInt1 + 1)
        ELSE
          LET tmp3 = 0
        END IF
        IF (tmp3 bAND %00001111) <> 0 THEN
          IF (tmp3 bAND %00001000) <> 0 THEN 'Es un tanque de combustible
            LET tmp4 = tmp3 bAND %00000111 'tenemos la altura del tanque
          ELSEIF ((RandomGen() bAND %11) <> 0) OR missilesBonus THEN 'Es un misil enemigo
            LET tmp5 = tmp3 bAND %00000111 'tenemos la altura del misil
          END IF
        END IF
        LET tmp6 = (eIndexY + tmp1) bAND %111
        LET eFuelTanksY(tmp6) = tmp4
        LET eMissilesY(tmp6) = tmp5
        LET eMissilesEn(tmp6) = FALSE
        'Activamos meteoros
        IF (tmp3 bAND %10000000) <> 0 THEN LET meteorsEnabled = NOT meteorsEnabled
        IF (tmp3 bAND %01000000) <> 0 THEN LET missilesEnabled = NOT missilesEnabled
        IF (tmp3 bAND %00100000) <> 0 THEN LET missilesBonus = NOT missilesBonus
        LET tmp6 = (eIndexYM + tmp1) bAND %111
        IF newPlayfield THEN LET eMeteorsY(tmp6) = 8
        IF meteorsEnabled AND tmp1 = 7 THEN
          LET tmp4 = RandomGen() bAND %111
          IF tmp4 > 6 THEN LET tmp4 = 6 - tmp4
          LET eMeteorsY(tmp6) = tmp4
        END IF
      END IF
      LET tmpInt0 = tmpInt0 + 1
      LET tmpInt1 = tmpInt1 + 2
      LET tmp1 = tmp1 + 1
    LOOP UNTIL tmp1 >= 8

    'Dibujamos meteoros
    LET tmp0 = 0
    DO
      LET tmp3 = (eIndexYM + tmp0) bAND %111
      LET tmp1 = eMeteorsY(tmp3)
      IF tmp1 < 8 THEN 
        POKE ((tmp1 << 3) + tmp0 + newPlayfieldPtr), BRICK
      END IF
      LET tmp0 = tmp0 + 1
    LOOP UNTIL tmp0 >= 8

    LET tmp0 = 0
    DO
      LET tmp3 = (eIndexY + tmp0) bAND %111
      LET tmp1 = eFuelTanksY(tmp3)
      LET tmp2 = eMissilesY(tmp3)
      IF tmp1 < 8 THEN 'Comprobar tanques
        POKE ((tmp1 << 3) + tmp0 + newPlayfieldPtr), FUELTANK
      END IF
      IF tmp2 < 8 THEN 'comprobar misiles enemigos
        LET tmpInt0 = ((tmp2 << 3) + tmp0 + newPlayfieldPtr)
        LET tmp4 = PEEK(tmpInt0)
        IF tmp4 = 0 THEN
          POKE tmpInt0, EMISSILE
        ELSE
          LET eMissilesY(tmp3) = 8
          LET eMissilesEn(tmp3) = FALSE
        END IF
      END IF
      LET tmp0 = tmp0 + 1
    LOOP UNTIL tmp0 >= 8

    IF by < 8 THEN 'Comprobar bomba jugador
      LET tmpInt0 = ((by << 3) + bx + newPlayfieldPtr)
      LET tmp0 = PEEK(tmpInt0)
      IF tmp0 = BRICK THEN
        LET by = 8
      ELSEIF tmp0 = EMISSILE THEN
        LET tmp3 = (eIndexY + bx) bAND %111
        IF missilesBonus THEN
          LET score = score + SCOREMISSSP
          LET loopComplete = TRUE
        ELSEIF eMissilesEn(tmp3) THEN
          LET score = score + SCOREMISSEN
        ELSE
          LET score = score + SCOREMISS
        END IF
        LET updateScore = TRUE
        LET eMissilesY(tmp3) = 8
        LET eMissilesEn(tmp3) = FALSE
        LET by = 8
        LET sfx = 3
        POKE tmpInt0, VOID
      ELSEIF tmp0 = FUELTANK THEN
        LET eFuelTanksY((eIndexY + bx) bAND %111) = 8
        LET fuel = fuel + EXTRAFUEL
        IF fuel > MAXFUEL THEN LET fuel = MAXFUEL
        LET updateFuel = TRUE
        LET score = score + SCOREFUEL
        LET updateScore = TRUE
        LET by = 8
        LET sfx = 4
        POKE tmpInt0, VOID
      ELSE
        POKE tmpInt0, PBOMB
      END IF
    END IF

    IF mx < 8 THEN 'Comprobar misil jugador
      LET tmpInt0 = ((my << 3) + mx + newPlayfieldPtr)
      LET tmp0 = PEEK(tmpInt0)
      IF tmp0 = BRICK THEN
        LET mx = 8
      ELSEIF tmp0 = EMISSILE THEN
        LET tmp3 = (eIndexY + mx) bAND %111
        IF missilesBonus THEN
          LET score = score + SCOREMISSSP
          LET loopComplete = TRUE
        ELSEIF eMissilesEn(tmp3) THEN
          LET score = score + SCOREMISSEN
        ELSE
          LET score = score + SCOREMISS
        END IF
        LET updateScore = TRUE
        LET eMissilesY(tmp3) = 8
        LET eMissilesEn(tmp3) = FALSE
        LET mx = 8
        LET sfx = 3
        POKE tmpInt0, VOID
      ELSEIF tmp0 = FUELTANK THEN
        LET eFuelTanksY((eIndexY + mx) bAND %111) = 8
        LET fuel = fuel + EXTRAFUEL
        IF fuel > MAXFUEL THEN LET fuel = MAXFUEL
        LET updateFuel = TRUE
        LET score = score + SCOREFUEL
        LET updateScore = TRUE
        LET mx = 8
        LET sfx = 4
        POKE tmpInt0, VOID
      ELSE
        POKE tmpInt0, PMISSILE
      END IF
    END IF

    IF py < 8 THEN 'comprobar jugador
      LET tmpInt0 = ((py << 3) + px + newPlayfieldPtr)
      LET tmp0 = PEEK(tmpInt0)
      IF deathState THEN
        IF (frameCont bAND 1) <> 0 THEN
          POKE tmpInt0, CHOPPER
        END IF
      ELSEIF tmp0 = BRICK OR _
        tmp0 = EMISSILE OR _
        tmp0 = FUELTANK THEN 'Impacto y muerte
          Death()
          POKE tmpInt0, CHOPPER
      ELSE
        POKE tmpInt0, CHOPPER
      END IF
    END IF

    SetScreenBufferAddr(BUFFERPXLADDR)
    SetAttrBufferAddr(BUFFERATTADDR)

    'Dibujamos campo de juego usando 'dirty tiles' para acelerar
    LET tmpInt0 = newPlayfieldPtr
    LET tmpInt1 = oldPlayfieldPtr
    LET tmpInt2 = @UdgColor(0)
    IF newPlayfield THEN
      LET tmp1 = 0
      DO
        LET tmp0 = 0
        DO
          LET tmp2 = PEEK(tmpInt0)
          IF (tmp2 = CHOPPER) AND NOT deathState THEN
            LET tmp2 = tmp2 + (frameCont bAND 1)
          END IF
          LET tmp4 = PEEK(tmpInt2 + tmp2)
          LET tmp2 = (tmp2 << 1) + $90
          PRINT AT tmp1, STARTCOL+(tmp0 << 1); INK tmp4; CHR$(tmp2); CHR$(tmp2+1);
          LET tmpInt0 = tmpInt0 + 1
          LET tmp0 = tmp0 + 1
        LOOP UNTIL tmp0 = 8
        LET tmp1 = tmp1 + 1
      LOOP UNTIL tmp1 = 8
      LET newPlayfield = FALSE
    ELSE
      LET tmp1 = 0
      DO
        LET tmp0 = 0
        DO
          LET tmp2 = PEEK(tmpInt0)
          LET tmp3 = (tmp2 = CHOPPER) AND NOT deathState
          IF PEEK(tmpInt1) <> tmp2 OR tmp3 THEN
            IF tmp3 THEN LET tmp2 = tmp2 + (frameCont bAND 1)
            LET tmp4 = PEEK(tmpInt2 + tmp2)
            LET tmp2 = (tmp2 << 1) + $90
            PRINT AT tmp1, STARTCOL+(tmp0 << 1); INK tmp4; CHR$(tmp2); CHR$(tmp2+1);
          END IF
          LET tmpInt0 = tmpInt0 + 1
          LET tmpInt1 = tmpInt1 + 1
          LET tmp0 = tmp0 + 1
        LOOP UNTIL tmp0 = 8
        LET tmp1 = tmp1 + 1
      LOOP UNTIL tmp1 = 8
    END IF

    'Intercambiar los mapas lógicos
    LET tmpInt0 = oldPlayfieldPtr
    LET oldPlayfieldPtr = newPlayfieldPtr
    LET newPlayfieldPtr = tmpInt0

    'Actualizar marcador combustible
    IF updateFuel THEN

      IF fuel > (1*(MAXFUEL/16)) THEN
        LET tmp7 = $90 + FUELGAUGE + 14
      ELSEIF fuel > (0*(MAXFUEL/16)) THEN
        LET tmp7 = $90 + FUELGAUGE + 15
      ELSE
        LET tmp7 = $20
      END IF

      IF fuel > (3*(MAXFUEL/16)) THEN
        LET tmp6 = $90 + FUELGAUGE + 12
      ELSEIF fuel > (2*(MAXFUEL/16)) THEN
        LET tmp6 = $90 + FUELGAUGE + 13
      ELSE
        LET tmp6 = $20
      END IF

      IF fuel > (5*(MAXFUEL/16)) THEN
        LET tmp5 = $90 + FUELGAUGE + 10
      ELSEIF fuel > (4*(MAXFUEL/16)) THEN
        LET tmp5 = $90 + FUELGAUGE + 11
      ELSE
        LET tmp5 = $20
      END IF

      IF fuel > (7*(MAXFUEL/16)) THEN
        LET tmp4 = $90 + FUELGAUGE + 8
      ELSEIF fuel > (6*(MAXFUEL/16)) THEN
        LET tmp4 = $90 + FUELGAUGE + 9
      ELSE
        LET tmp4 = $20
      END IF

      IF fuel > (9*(MAXFUEL/16)) THEN
        LET tmp3 = $90 + FUELGAUGE + 6
      ELSEIF fuel > (8*(MAXFUEL/16)) THEN
        LET tmp3 = $90 + FUELGAUGE + 7
      ELSE
        LET tmp3 = $20
      END IF

      IF fuel > (11*(MAXFUEL/16)) THEN
        LET tmp2 = $90 + FUELGAUGE + 4
      ELSEIF fuel > (10*(MAXFUEL/16)) THEN
        LET tmp2 = $90 + FUELGAUGE + 5
      ELSE
        LET tmp2 = $20
      END IF

      IF fuel > (13*(MAXFUEL/16)) THEN
        LET tmp1 = $90 + FUELGAUGE + 2
      ELSEIF fuel > (12*(MAXFUEL/16)) THEN
        LET tmp1 = $90 + FUELGAUGE + 3
      ELSE
        LET tmp1 = $20
      END IF

      IF fuel > (15*(MAXFUEL/16)) THEN
        LET tmp0 = $90 + FUELGAUGE + 0
      ELSEIF fuel > (14*(MAXFUEL/16)) THEN
        LET tmp0 = $90 + FUELGAUGE + 1
      ELSE
        LET tmp0 = $20
      END IF

      PRINT INK 5; AT 0, FUELCOL; CHR$(tmp0);_
       INK 5; AT 1, FUELCOL; CHR$(tmp1);_
       INK 5; AT 2, FUELCOL; CHR$(tmp2);_
       INK 4; AT 3, FUELCOL; CHR$(tmp3);_
       INK 4; AT 4, FUELCOL; CHR$(tmp4);_
       INK 4; AT 5, FUELCOL; CHR$(tmp5);_
       INK 2; AT 6, FUELCOL; CHR$(tmp6);_
       INK 2; AT 7, FUELCOL; CHR$(tmp7);

      LET updateFuel = FALSE
    END IF

    'Actualizar marcador vidas/fase
    IF updateState THEN

      IF lives >= 1 THEN
        LET tmp1 = $90 + 2*CHOPPER
        LET tmp2 = $90 + 2*CHOPPER + 1
      ELSE
        LET tmp1 = $20
        LET tmp2 = $20
      END IF

      IF lives >= 2 THEN
        LET tmp3 = $90 + 2*CHOPPER
        LET tmp4 = $90 + 2*CHOPPER + 1
      ELSE
        LET tmp3 = $20
        LET tmp4 = $20
      END IF

      IF lives >= 3 THEN
        LET tmp5 = $90 + 2*CHOPPER
        LET tmp6 = $90 + 2*CHOPPER + 1
      ELSE
        LET tmp5 = $20
        LET tmp6 = $20
      END IF

      PRINT AT HEIGHT-1,DATACOL; CHR$(tmp1); CHR$(tmp2);_
        AT HEIGHT-2,DATACOL; CHR$(tmp3); CHR$(tmp4);_
        AT HEIGHT-3,DATACOL; CHR$(tmp5); CHR$(tmp6);

      IF stage >= 1 THEN
        LET tmp1 = $90 + STAGEICON
        LET tmp2 = $90 + STAGEICON + 1
      ELSE
        LET tmp1 = $20
        LET tmp2 = $20
      END IF

      IF stage >= 2 THEN
        LET tmp3 = $90 + STAGEICON + 2
        LET tmp4 = $90 + STAGEICON + 1 + 2
      ELSE
        LET tmp3 = $20
        LET tmp4 = $20
      END IF

      IF stage >= 3 THEN
        LET tmp5 = $90 + STAGEICON + 4
        LET tmp6 = $90 + STAGEICON + 1 + 4
      ELSE
        LET tmp5 = $20
        LET tmp6 = $20
      END IF

      IF stage >= 4 THEN
        LET tmp7 = $90 + STAGEICON + 6
        LET tmp8 = $90 + STAGEICON + 1 + 6
      ELSE
        LET tmp7 = $20
        LET tmp8 = $20
      END IF

      IF stage >= 5 THEN
        LET tmp9 = $90 + STAGEICON + 8
        LET tmp10 = $90 + STAGEICON + 1 + 8
      ELSE
        LET tmp9 = $20
        LET tmp10 = $20
      END IF

      PRINT AT 0,DATACOL; CHR$(tmp1); CHR$(tmp2);_
        AT 1,DATACOL; CHR$(tmp3); CHR$(tmp4);_
        AT 2,DATACOL; CHR$(tmp5); CHR$(tmp6);_
        AT 3,DATACOL; CHR$(tmp7); CHR$(tmp8);_
        AT 4,DATACOL; CHR$(tmp9); CHR$(tmp10);

      LET updateState = FALSE
    END IF

    'Copiando buffer a pantalla
    'waitretrace
    MemCopy(BUFFERATTADDR, $5900, BUFFERATTSIZE)
    MemCopy(BUFFERPXLADDR, $4800, BUFFERPLXSIZE)
    
    SetScreenBufferAddr(screenPxlPtr)
    SetAttrBufferAddr(screenAttPtr)

    'Dibuja puntuación
    PRINT AT STARTROW-1, STARTCOL+9; scoreStr;

    IF updateScore THEN
      IF NOT extraLifeGiven THEN
        IF score >= 1000 THEN
          LET lives = lives + 1
          LET extraLifeGiven = TRUE
          LET updateState = TRUE
        END IF
      END IF
      SetScoreString()
      LET updateScore = FALSE
    END IF

    IF NOT deathState THEN

      'Efectos de sonido
      IF sfx > 0 THEN
        IF sfx = 1 THEN 'Misil
          BEEP 0.005, 10
          BEEP 0.005, 12
          BEEP 0.005, 14
          BEEP 0.005, 16
          BEEP 0.005, 18
          BEEP 0.005, 20
        ELSEIF sfx = 2 THEN 'Bomba
          BEEP 0.02, 20
          BEEP 0.02, 18
          BEEP 0.02, 16
          BEEP 0.02, 14
          BEEP 0.02, 12
        ELSEIF sfx = 3 THEN 'misil enemigo destruido
          BEEP 0.05, 20
          BEEP 0.05, 15
          BEEP 0.05, 10
        ELSEIF sfx = 4 THEN 'tanque de combustible destruido
          BEEP 0.025, 10
          BEEP 0.025, 16
          BEEP 0.025, 10
          BEEP 0.025, 16
          BEEP 0.025, 10
          BEEP 0.025, 16
          BEEP 0.025, 10
        END IF
        LET sfx = 0
      END IF


      'Lectura de Teclado
      IF kempston THEN
        LET tmp0 = IN 31
        LET keyUpPressed = (tmp0 bAND %01000) <> 0
        LET keyDownPressed = (tmp0 bAND %00100) <> 0
        LET keyLeftPressed = (tmp0 bAND %00010) <> 0
        LET keyRightPressed = (tmp0 bAND %00001) <> 0
        LET keyBombPressed = MultiKeys(keyBomb)
        LET keyShotPressed = (tmp0 bAND %10000) <> 0
      ELSE
        LET keyUpPressed = MultiKeys(keyUp)
        LET keyDownPressed = MultiKeys(keyDown)
        LET keyLeftPressed = MultiKeys(keyLeft)
        LET keyRightPressed = MultiKeys(keyRight)
        LET keyBombPressed = MultiKeys(keyBomb)
        LET keyShotPressed = MultiKeys(keyShot)
      END IF


      'Scroll y misiles cada 4 frames
      'Meteoros y helicoptero cada dos frames
      LET tmp0 = ((frameCont bAND %1) = %00)
      LET tmp1 = ((frameCont bAND %11) = %00)
      LET tmp2 = ((frameCont bAND %111) = %000)

      LET tmp3 = tmp1 OR (tmp0 AND loopComplete)

      IF tmp0 THEN

        'Movemos helicóptero
        IF keyUpPressed <> 0 THEN
          IF py > 0 THEN LET py = py - 1
        END IF
        IF keyLeftPressed <> 0 THEN
          IF px > 0 THEN LET px = px - 1
        END IF
        IF keyDownPressed <> 0 THEN
          IF py < 7  THEN LET py = py + 1
        END IF
        IF keyRightPressed <> 0 THEN
          IF px < 4 THEN LET px = px + 1
        END IF
      END IF

      IF tmp3 THEN

        'Movemos meteoros
        LET eMeteorsY(eIndexYM) = 8 'Borramos la última fila
        LET eIndexYM = (eIndexYM + 1) bAND %111
        
      END IF

      'Movemos misiles
      IF mx < 8 THEN
        LET mx = mx + 1
      ELSEIF keyShotPressed <> 0 THEN
        LET mx = px + 1
        LET my = py
        LET sfx = 1
      END IF

      'Movemos bombas
      IF by < 8 THEN
        IF tmp2 THEN LET by = by + 1
      ELSEIF keyBombPressed <> 0 THEN
        LET bx = px
        LET by = py + 1
        LET sfx = 2
      END IF


      IF tmp1 THEN

        'Actualizamos misiles enemigos
        LET tmp4 = 0
        DO
          LET tmp3 = eMissilesY(tmp4)
          IF eMissilesEn(tmp4) THEN
            IF tmp3 < 8 THEN
              LET eMissilesY(tmp4) = tmp3 - 1
            ELSE
              LET eMissilesEn(tmp4) = FALSE
              LET eMissilesY(tmp4) = 8
            END IF
          ELSEIF missilesEnabled THEN 'En la fase 2 no se activan los misiles
            IF tmp3 < 5 AND RandomGen() <= 20 THEN 'Activar misiles
              LET eMissilesEn(tmp4) = TRUE
            END IF
          END IF
          LET tmp4 = tmp4 + 1
        LOOP UNTIL tmp4 >= 8

      END IF

      IF tmp2 THEN

        'Hace scroll al mapa
        IF y >= stageSize THEN RETURN TRUE 'Fin del mapa
        LET y = y + 1
        LET mapPtr = mapPtr + 2
        LET eMissilesY(eIndexY) = 8
        LET eMissilesEn(eIndexY) = FALSE
        LET eIndexY = (eIndexY + 1) bAND %111
        LET scrollDone = TRUE
        LET score = score + SCORELEFT
        LET updateScore = TRUE
        IF fuel > 0 THEN
          LET fuel = fuel - 1
        ELSE
          Death()
        END IF
        LET updateFuel = TRUE

      END IF

    ELSE 'Estamos muriendo :-(

      BEEP 0.05, 14
      BEEP 0.05, 18
      IF frameCont > 8 THEN EXIT DO

    END IF

    LET frameCont = frameCont + 1

  LOOP

  RETURN FALSE

END FUNCTION


'
' Logo begins on COL 5: ROW 0
' HEIGHT = 5
' WIDTH = 24
'===========================================================
'Programa principal
BORDER 0 : PAUSE 2*50

LET screenPxlPtr = GetScreenBufferAddr()
LET screenAttPtr = GetAttrBufferAddr()
LET UDG = @UdgSet(0)
LET CHARS = @CharSet(0)-256
SetDefaultKeys()


#ifdef CHEAT
'Cheat test
LET cheatMode = TRUE
#endif

DO
  ShowMenuScreen()
  PRINT AT 6, 9; INK 5; BRIGHT 1; "1 "; INK 4; BRIGHT 1; "- Keyboard";_
    AT 8, 9; INK 5; BRIGHT 1; "2 "; INK 4; BRIGHT 1; "- Kempston";_
    AT 10, 9; INK 5; BRIGHT 1; "3 "; INK 4; BRIGHT 1; "- Sinclair 1";_
    AT 12, 9; INK 5; BRIGHT 1; "4 "; INK 4; BRIGHT 1; "- Sinclair 2";_
    AT 14, 9; INK 5; BRIGHT 1; "5 "; INK 4; BRIGHT 1; "- Redefine";_
    AT 18, 7; INK 6; BRIGHT 0; "High Score: "; INK 5; BRIGHT 1; STR(hiScore);_
    AT 22, 5; INK 4; BRIGHT 1;"(C) Cronomantic - 2023";

  DO
    LET tmp0 = GetKey()
  LOOP UNTIL tmp0 >= 49 AND tmp0 <= 53

  IF tmp0 = 53 THEN 'Redefinir teclas

    ShowMenuScreen()
    PRINT AT 12, 8; BRIGHT 1; "Press Left Key ";
    keyLeft = GetRedefinedKey()
    PRINT AT 12, 8; BRIGHT 1; "Press Right Key";
    keyRight = GetRedefinedKey()
    PRINT AT 12, 8; BRIGHT 1; "Press Up Key   ";
    keyUp = GetRedefinedKey()
    PRINT AT 12, 8; BRIGHT 1; "Press Down Key ";
    keyDown = GetRedefinedKey()
    PRINT AT 12, 8; BRIGHT 1; "Press Fire Key ";
    keyShot = GetRedefinedKey()
    PRINT AT 12, 8; BRIGHT 1; "Press Bomb Key ";
    keyBomb = GetRedefinedKey()
    PAUSE 1

  ELSE 'Comenzar juego

    IF tmp0 = 51 THEN
      SetSJ1Keys()
    ELSEIF tmp0 = 52 THEN
      SetSJ2Keys()
    ELSE
      LET kempston = (tmp0 = 50)
    END IF

    INK 0: PAPER 0 : CLS

    'descomprimimos el borde en pantalla
    dzx0Mega(@marqueePxl(0), $4000)
    dzx0Mega(@marqueeAtt(0), $5800)

    'Copiar el tercio de la marquesina al buffer
    MemCopy($4800, BUFFERPXLADDR, BUFFERPLXSIZE)
    MemCopy($5900, BUFFERATTADDR, BUFFERATTSIZE)

    BORDER 4: INK 5

    LET randomSeed = FRAMES
    RandomGen()


    LET lives = 2
    LET loopComplete = FALSE

#ifdef CHEAT
    LET stage = 5
#else
    LET stage = 1
#endif

    LET score = 0
    LET extraLifeGiven = FALSE
    RestorePlayer()

    DO
      IF MainLoop() THEN
        IF stage = 5 THEN
          LET stage = 1
        ELSE
          LET stage = stage + 1
        END IF
      ELSE
        IF lives = 0 THEN EXIT DO
        IF NOT cheatMode THEN LET lives = lives - 1
#ifndef CHEAT
        'Si morimos en la fase especial, saltamos a la fase 1
        IF stage = 5 THEN LET stage = 1
#endif
        RestorePlayer()
      END IF
    LOOP

    'Game Over!
    PAUSE 1: PAUSE 50 * 2
    ShowMenuScreen()
    PRINT AT 7, 6; INK 2; BRIGHT 1; "G A M E    O V E R";_
      AT 8, 6; "------------------";_
      AT 11, 7; INK 4; BRIGHT 1; "Your Score: "; INK 5; BRIGHT 1; STR(score); _
      AT 13, 7; INK 6; BRIGHT 1; "High Score: ";
    IF score > hiScore THEN
      LET hiScore = score
      PRINT INK 5; BRIGHT 1; FLASH 1; STR(score);
    ELSE
      PRINT INK 5; BRIGHT 1; STR(hiScore);
    END IF
    PRINT AT 16, 7; "Press any key...";
    PAUSE 0

  END IF

LOOP
